searchNodes=[{"doc":"Generates native boilerplate code for all the .spec.exs files found in c_src dir","ref":"Mix.Tasks.Compile.Unifex.html","title":"Mix.Tasks.Compile.Unifex","type":"task"},{"doc":"Implementation of Bundlex.Preprocessor . When added to a native configuration in Bundlex.Project , equips the native with the Unifex native dependency and generated sources.","ref":"Unifex.html","title":"Unifex","type":"module"},{"doc":"Wraps Bundlex.CNode functionalities to support Unifex-specific CNode behaviours","ref":"Unifex.CNode.html","title":"Unifex.CNode","type":"module"},{"doc":"Makes a synchronous call to CNode and waits for its reply. If the response doesn't come in within timeout , error is raised. Messages are exchanged directly (without interacting with CNode's associated server).","ref":"Unifex.CNode.html#call/4","title":"Unifex.CNode.call/4","type":"function"},{"doc":"Starts monitoring CNode from the calling process.","ref":"Unifex.CNode.html#monitor/1","title":"Unifex.CNode.monitor/1","type":"function"},{"doc":"Works the same way as start_link/1 , but does not link to CNode's associated server.","ref":"Unifex.CNode.html#start/1","title":"Unifex.CNode.start/1","type":"macro"},{"doc":"Works the same way as start_link/2 , but does not link to CNode's associated server.","ref":"Unifex.CNode.html#start/2","title":"Unifex.CNode.start/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name . For details, see Bundlex.CNode.start_link/2 .","ref":"Unifex.CNode.html#start_link/1","title":"Unifex.CNode.start_link/1","type":"macro"},{"doc":"Spawns and connects to CNode cnode_name from application app . For details, see Bundlex.CNode.start_link/2 .","ref":"Unifex.CNode.html#start_link/2","title":"Unifex.CNode.start_link/2","type":"function"},{"doc":"Disconnects from CNode.","ref":"Unifex.CNode.html#stop/1","title":"Unifex.CNode.stop/1","type":"function"},{"doc":"","ref":"Unifex.CNode.html#t:on_start_t/0","title":"Unifex.CNode.on_start_t/0","type":"type"},{"doc":"","ref":"Unifex.CNode.html#t:t/0","title":"Unifex.CNode.t/0","type":"type"},{"doc":"Behaviour for code generation.","ref":"Unifex.CodeGenerator.html","title":"Unifex.CodeGenerator","type":"behaviour"},{"doc":"","ref":"Unifex.CodeGenerator.html#bundlex_interface/1","title":"Unifex.CodeGenerator.bundlex_interface/1","type":"function"},{"doc":"Generates boilerplate code using generator implementation from Unifex.CodeGenerators .","ref":"Unifex.CodeGenerator.html#generate_code/1","title":"Unifex.CodeGenerator.generate_code/1","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.html#c:generate_header/1","title":"Unifex.CodeGenerator.generate_header/1","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.html#c:generate_source/1","title":"Unifex.CodeGenerator.generate_source/1","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.html#c:identification_constant/0","title":"Unifex.CodeGenerator.identification_constant/0","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.html#interface_generator/1","title":"Unifex.CodeGenerator.interface_generator/1","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.html#c:interface_io_name/0","title":"Unifex.CodeGenerator.interface_io_name/0","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.html#t:code_t/0","title":"Unifex.CodeGenerator.code_t/0","type":"type"},{"doc":"","ref":"Unifex.CodeGenerator.html#t:generated_code_t/0","title":"Unifex.CodeGenerator.generated_code_t/0","type":"type"},{"doc":"","ref":"Unifex.CodeGenerator.html#t:t/0","title":"Unifex.CodeGenerator.t/0","type":"type"},{"doc":"Behaviour and abstraction over type-specific code generation. When invoking callbacks for type :type and interface Interface it searches for a module that implements given callback in the following order: Unifex.CodeGenerator.BaseTypes.Type.Interface Unifex.CodeGenerator.BaseTypes.Type Unifex.CodeGenerator.BaseTypes.Default.Interface","ref":"Unifex.CodeGenerator.BaseType.html","title":"Unifex.CodeGenerator.BaseType","type":"behaviour"},{"doc":"","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_name/4","title":"Unifex.CodeGenerator.BaseType.generate_arg_name/4","type":"function"},{"doc":"Generates function call parsing UNIFEX_TERM argument into the native variable with name variable . Function should return boolean value.","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_arg_parse/3","title":"Unifex.CodeGenerator.BaseType.generate_arg_parse/3","type":"callback"},{"doc":"Generates parsing of UNIFEX_TERM argument into the native variable","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_parse/6","title":"Unifex.CodeGenerator.BaseType.generate_arg_parse/6","type":"function"},{"doc":"Provides a way to convert native variable name into UNIFEX_TERM","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_arg_serialize/2","title":"Unifex.CodeGenerator.BaseType.generate_arg_serialize/2","type":"callback"},{"doc":"Provides a way to convert native variable name into UNIFEX_TERM Tries to get value from type-specific module, uses enif_make_\#{type} as fallback value.","ref":"Unifex.CodeGenerator.BaseType.html#generate_arg_serialize/4","title":"Unifex.CodeGenerator.BaseType.generate_arg_serialize/4","type":"function"},{"doc":"Generates a declaration of parameter (to be placed in function header) based on generate_native_type/1 and provided name . Uses type as fallback for generate_native_type/1 When mode is set to :const_unless_ptr_on_ptr, function will choose to behave like it would be set to :default or :const, depending on value returned by ptr_level(type, code_generator, ctx) . This mode can be used in places, when in general, you want to have declaration of variable with const type, but using :const mode would generate code, that would require explicit cast to avoid generating warnings during compilation - e.g. in C, passing argument of type char ** to function, that expects argument of type char const * const * without any explicit cast, will generate such a warning","ref":"Unifex.CodeGenerator.BaseType.html#generate_declaration/5","title":"Unifex.CodeGenerator.BaseType.generate_declaration/5","type":"function"},{"doc":"Generates a destruction of variable content. Should be paired with generate_initialization/2","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_destruction/2","title":"Unifex.CodeGenerator.BaseType.generate_destruction/2","type":"callback"},{"doc":"Generates an destrucition of variable content. Should be paired with generate_initialization/1 Returns an empty string if the type does not provide destructor","ref":"Unifex.CodeGenerator.BaseType.html#generate_destruction/4","title":"Unifex.CodeGenerator.BaseType.generate_destruction/4","type":"function"},{"doc":"Generates an initialization of variable content. Should be paired with generate_destruction/2","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_initialization/2","title":"Unifex.CodeGenerator.BaseType.generate_initialization/2","type":"callback"},{"doc":"Generates an initialization of variable content. Should be paired with generate_destruction/1 Returns an empty string if the type does not provide initialization","ref":"Unifex.CodeGenerator.BaseType.html#generate_initialization/4","title":"Unifex.CodeGenerator.BaseType.generate_initialization/4","type":"function"},{"doc":"Generates a native counterpart for the type.","ref":"Unifex.CodeGenerator.BaseType.html#c:generate_native_type/1","title":"Unifex.CodeGenerator.BaseType.generate_native_type/1","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.BaseType.html#generate_native_type/4","title":"Unifex.CodeGenerator.BaseType.generate_native_type/4","type":"function"},{"doc":"Returns level of pointer nesting of native type.","ref":"Unifex.CodeGenerator.BaseType.html#c:ptr_level/1","title":"Unifex.CodeGenerator.BaseType.ptr_level/1","type":"callback"},{"doc":"","ref":"Unifex.CodeGenerator.BaseType.html#ptr_level/3","title":"Unifex.CodeGenerator.BaseType.ptr_level/3","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.BaseType.html#t:arg_parse_ctx_t/0","title":"Unifex.CodeGenerator.BaseType.arg_parse_ctx_t/0","type":"type"},{"doc":"","ref":"Unifex.CodeGenerator.BaseType.html#t:t/0","title":"Unifex.CodeGenerator.BaseType.t/0","type":"type"},{"doc":"Utilities for code generation.","ref":"Unifex.CodeGenerator.Utils.html","title":"Unifex.CodeGenerator.Utils","type":"module"},{"doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_enums_definitions/3","title":"Unifex.CodeGenerator.Utils.generate_enums_definitions/3","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_functions/3","title":"Unifex.CodeGenerator.Utils.generate_functions/3","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_functions_declarations/3","title":"Unifex.CodeGenerator.Utils.generate_functions_declarations/3","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_maybe_unused_args_statements/1","title":"Unifex.CodeGenerator.Utils.generate_maybe_unused_args_statements/1","type":"function"},{"doc":"Traverses Elixir specification AST and creates C data types serialization with serializers .","ref":"Unifex.CodeGenerator.Utils.html#generate_serialization/2","title":"Unifex.CodeGenerator.Utils.generate_serialization/2","type":"function"},{"doc":"","ref":"Unifex.CodeGenerator.Utils.html#generate_structs_definitions/3","title":"Unifex.CodeGenerator.Utils.generate_structs_definitions/3","type":"function"},{"doc":"Replaces special characters such as: . , -&gt; and array brackets e.g. var_name[i] with underscores. In case of arrays var_name[i] results in var_name_i .","ref":"Unifex.CodeGenerator.Utils.html#sanitize_var_name/1","title":"Unifex.CodeGenerator.Utils.sanitize_var_name/1","type":"function"},{"doc":"Sigil used for templating generated code.","ref":"Unifex.CodeGenerator.Utils.html#sigil_g/2","title":"Unifex.CodeGenerator.Utils.sigil_g/2","type":"function"},{"doc":"This module allows to generate definitions for native functions described in Unifex specs. To achieve that simply use this module: use Unifex.Loader","ref":"Unifex.Loader.html","title":"Unifex.Loader","type":"module"},{"doc":"Module that handles parsing Unifex specs for native boilerplate code generation. For information on how to create such specs, see Unifex.Specs.DSL module.","ref":"Unifex.Specs.html","title":"Unifex.Specs","type":"module"},{"doc":"Parses Unifex specs of native functions.","ref":"Unifex.Specs.html#parse/2","title":"Unifex.Specs.parse/2","type":"function"},{"doc":"","ref":"Unifex.Specs.html#t:enum_t/0","title":"Unifex.Specs.enum_t/0","type":"type"},{"doc":"Name of interface generated for the native library. Must be a suffix of code generator module in Unifex.CodeGenerators namespace. Unifex has built-in generators for NIF and CNode interfaces.","ref":"Unifex.Specs.html#t:interface_t/0","title":"Unifex.Specs.interface_t/0","type":"type"},{"doc":"","ref":"Unifex.Specs.html#t:native_name_t/0","title":"Unifex.Specs.native_name_t/0","type":"type"},{"doc":"","ref":"Unifex.Specs.html#t:struct_t/0","title":"Unifex.Specs.struct_t/0","type":"type"},{"doc":"","ref":"Unifex.Specs.html#t:t/0","title":"Unifex.Specs.t/0","type":"type"},{"doc":"Module exporting macros that can be used to define Unifex specs. Example of such specs is provided below: module Membrane.Element.Mad.Decoder.Native type position :: :manager | :developer | :intern | :product_owner type personal_data :: % PersonalData { age : int , experience : int , name : string } spec get_salary ( person :: personal_data , person_position :: position ) :: { :ok :: label , salary :: int } { :error :: label , :unemployed :: label } spec create ( ) :: { :ok :: label , state } spec decode_frame ( payload , offset :: int , state ) :: { :ok :: label , { payload , bytes_used :: long , sample_rate :: long , channels :: int } } | { :error :: label , :buflen :: label } | { :error :: label , :malformed :: label } | { :error :: label , { :recoverable :: label , bytes_to_skip :: int } } dirty :cpu , decode_frame : 3 sends { :example_msg :: label , number :: int } According to this specification, module Membrane.Element.Mad.Decoder.Native should contain 2 functions: create/0 and decode_frame/3 (which is a cpu-bound dirty NIF). The module should use Unifex.Loader to provide access to these functions. What is more, messages of the form {:example_msg, integer} can be sent from the native code to erlang processes. Following types definitions will be generated and will be available from native code #ifdef __cplusplus enum Position { MANAGER , DEVELOPER , INTERN , PRODUCT_OWNER } ; #else enum Position_t { MANAGER , DEVELOPER , INTERN , PRODUCT_OWNER } ; typedef enum Position_t Position ; #endif #ifdef __cplusplus struct personal_data { int age ; int experience ; char * name ; } ; #else struct personal_data_t { int age ; int experience ; char * name ; } ; typedef struct personal_data_t personal_data ; #endif The generated boilerplate would require implementation of the following functions: UNIFEX_TERM get_salary ( UnifexEnv * env , personal_data person , Position person_position ) ; UNIFEX_TERM create ( UnifexEnv * env ) ; UNIFEX_TERM decode_frame ( UnifexEnv * env , UnifexPayload * payload , int offset , State * state ) ; Also the following functions that should be called to return results will be generated: UNIFEX_TERM get_salary_result_ok ( UnifexEnv * env , int salary ) ; UNIFEX_TERM get_salary_result_error_unemployed ( UnifexEnv * env ) ; UNIFEX_TERM create_result_ok ( UnifexEnv * env , State * state ) ; UNIFEX_TERM decode_frame_result_ok ( UnifexEnv * env , UnifexPayload * payload , long bytes_used , long sample_rate , int channels ) ; UNIFEX_TERM decode_frame_result_error_buflen ( UnifexEnv * env ) ; UNIFEX_TERM decode_frame_result_error_malformed ( UnifexEnv * env ) ; UNIFEX_TERM decode_frame_result_error_recoverable ( UnifexEnv * env , int bytes_to_skip ) ; See docs for appropriate macros for more details.","ref":"Unifex.Specs.DSL.html","title":"Unifex.Specs.DSL","type":"module"},{"doc":"Defines native function documentation. Documentation will be visible in the generated docs. The documentation should be in the form of @doc &quot;&quot;&quot; Documentation... &quot;&quot;&quot; spec function_name ...","ref":"Unifex.Specs.DSL.html#@/1","title":"Unifex.Specs.DSL.@/1","type":"macro"},{"doc":"Defines names of callbacks invoked on specified hook. The available hooks are: :load - invoked when the library is loaded. Callback must have the following typing: int on_load(UnifexEnv *env, void ** priv_data) The callback receives an env and a pointer to private data that is initialized with NULL and can be set to whatever should be passed to other callbacks. If callback returns anything else than 0, the library fails to load. :upgrade - called when the library is loaded while there is old code for this module with a native library loaded. Compared to :load , it also receives old_priv_data : int on_upgrade(UnifexEnv* env, void** priv_data, void** old_priv_data) Both old and new private data can be modified If this callback is not defined, the module code cannot be hot-swapped. Non-zero return value also prevents code upgrade. :unload - called when the code for module is unloaded. It has the following declaration: void on_unload(UnifexEnv *env, void * priv_data)","ref":"Unifex.Specs.DSL.html#callback/2","title":"Unifex.Specs.DSL.callback/2","type":"macro"},{"doc":"Macro used for marking functions as dirty, i.e. performing long cpu-bound or io-bound operations. The macro should be used the following way: dirty type , function1 : function1_arity , ... when type is one of: :cpu - marks function as CPU-bound (maps to the ERL_NIF_DIRTY_JOB_CPU_BOUND erlang flag) :io - marks function as IO-bound (maps to the ERL_NIF_DIRTY_JOB_IO_BOUND erlang flag)","ref":"Unifex.Specs.DSL.html#dirty/2","title":"Unifex.Specs.DSL.dirty/2","type":"macro"},{"doc":"Specifies interface, for example NIF or CNode. It should be a module name (or list of module names) that will be prepended with Unifex.CodeGenerators . If no interface is specified, it is automatically detected basing on Bundlex.Project specification.","ref":"Unifex.Specs.DSL.html#interface/1","title":"Unifex.Specs.DSL.interface/1","type":"macro"},{"doc":"Defines module that exports native functions to Elixir world. The module needs to be defined manually, but it can use Unifex.Loader to have functions declared with spec/1 automatically defined.","ref":"Unifex.Specs.DSL.html#module/1","title":"Unifex.Specs.DSL.module/1","type":"macro"},{"doc":"Defines terms that can be sent from the native code to elixir processes. Creates native function that can be invoked to send specified data. Name of the function starts with send_ and is constructed from label s.","ref":"Unifex.Specs.DSL.html#sends/1","title":"Unifex.Specs.DSL.sends/1","type":"macro"},{"doc":"Defines native function specification. The specification should be in the form of spec function_name ( parameter1 :: parameter1_type , some_type , parameter3 :: parameter3_type , ... ) :: { :label1 :: label , { result_value1 :: result_value1_type , some_type2 , ... } } | { :label2 :: label , other_result_value2 :: other_result_value2_type } Parameters Specs for parameters can either take the form of parameter1 :: parameter1_type which will generate parameter with name parameter1 of type parameter1_type The other form - just a name, like some_type - will generate parameter some_type of type some_type . Custom types can be added by creating modules Unifex.CodeGenerator.BaseTypes.Type that implement Unifex.CodeGenerator.BaseType behaviour. Then, they can by used in specs as type . Each generated function gets additional UnifexEnv* env as the first parameter implicitly. Returned values Specs for returned values contain a special type - label . An atom of type label will be put literally in returned values by the special function generated for each spec. Names of the generated functions start with Elixir function name (e.g. create ) followed by _result_ part and then all the labels joined with _ . Example The example is provided in the moduledoc of this module.","ref":"Unifex.Specs.DSL.html#spec/1","title":"Unifex.Specs.DSL.spec/1","type":"macro"},{"doc":"Defines the state type, required for using Unifex.CodeGenerator.BaseTypes.State .","ref":"Unifex.Specs.DSL.html#state_type/1","title":"Unifex.Specs.DSL.state_type/1","type":"macro"},{"doc":"Contains user custom type specification Currently supported types are enums and structs The struct specification should be in the form of type my_struct :: % My.Struct { field1 : type1 , field2 : type2 , ... } The enum specification should be in the form of type my_enum :: :option_one | :option_two | :option_three | ... Struct or enums specified in such way can be used in like any other supported type, E.g. spec my_function ( in_enum :: my_enum ) :: { :ok :: label , out_struct :: my_struct } Elixir definition of %My.Struct{} should contain every field listed in specification and is not generated by Unifex","ref":"Unifex.Specs.DSL.html#type/1","title":"Unifex.Specs.DSL.type/1","type":"macro"},{"doc":"Generates C node boilerplate based on Unifex.Specs .","ref":"Unifex.CodeGenerators.CNode.html","title":"Unifex.CodeGenerators.CNode","type":"module"},{"doc":"Generates NIF boilerplate based on Unifex.Specs .","ref":"Unifex.CodeGenerators.NIF.html","title":"Unifex.CodeGenerators.NIF","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for atoms. Atoms in native code are represented by C-strings ( char * ) Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Atom.html","title":"Unifex.CodeGenerator.BaseTypes.Atom","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for boolean atoms. Booleans in native code are converted to int with value either 0 or 1. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Bool.html","title":"Unifex.CodeGenerator.BaseTypes.Bool","type":"module"},{"doc":"Default Unifex.CodeGenerator.BaseType implementation for all types. If a callback is not implemented in a type-specific implementation, it defaults to this one.","ref":"Unifex.CodeGenerator.BaseTypes.Default.html","title":"Unifex.CodeGenerator.BaseTypes.Default","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for C Enums. Implemented both for NIF and CNode.","ref":"Unifex.CodeGenerator.BaseTypes.Enum.html","title":"Unifex.CodeGenerator.BaseTypes.Enum","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for floats. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Float.html","title":"Unifex.CodeGenerator.BaseTypes.Float","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for integers. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Int.html","title":"Unifex.CodeGenerator.BaseTypes.Int","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for 64-bit integer. Maps int64 Unifex type to an int64_t native type. Implemented only for NIF as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Int64.html","title":"Unifex.CodeGenerator.BaseTypes.Int64","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for lists. They are represented in the native code as arrays with sizes passed via separate arguments. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.List.html","title":"Unifex.CodeGenerator.BaseTypes.List","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for payloads. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Payload.html","title":"Unifex.CodeGenerator.BaseTypes.Payload","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for Erlang PIDs. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Pid.html","title":"Unifex.CodeGenerator.BaseTypes.Pid","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for Unifex state. To use it, specify the state type with Unifex.Specs.DSL.state_type/1 .","ref":"Unifex.CodeGenerator.BaseTypes.State.html","title":"Unifex.CodeGenerator.BaseTypes.State","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for strings. They are represented by NULL-terminated char arrays. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.String.html","title":"Unifex.CodeGenerator.BaseTypes.String","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for structs. Elixir structs in native code are represented by C structs. Implemented both for NIF and CNode.","ref":"Unifex.CodeGenerator.BaseTypes.Struct.html","title":"Unifex.CodeGenerator.BaseTypes.Struct","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for 64-bit unsigned integer. Maps uint64 Unifex type to a uint64_t native type. Implemented only for NIF as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Uint64.html","title":"Unifex.CodeGenerator.BaseTypes.Uint64","type":"module"},{"doc":"Module implementing Unifex.CodeGenerator.BaseType behaviour for unsigned int. Implemented both for NIF and CNode as function parameter as well as return type.","ref":"Unifex.CodeGenerator.BaseTypes.Unsigned.html","title":"Unifex.CodeGenerator.BaseTypes.Unsigned","type":"module"},{"doc":"Unifex is a tool for generating interfaces between native C code and Elixir, that: provides intuitive and concise tools for defining native interfaces, generates all the boilerplate for you, provides useful abstractions over binaries and state, makes native code independent from erl_nif or ei library, so the same code is usable either with NIFs or CNodes. API documentation is available at HexDocs . Unifex uses Bundlex to compile and load the native code. See there for supported platforms &amp; details. This tool is maintained by the Membrane Framework team.","ref":"readme.html","title":"Unifex","type":"extras"},{"doc":"To install, you need to configure Mix project as follows: defmodule MyApp.Mixfile do use Mix.Project def project do [ app : :my_app , compilers : [ :unifex , :bundlex ] ++ Mix . compilers , # add unifex and bundlex to compilers ... , deps : deps ( ) ] end defp deps ( ) do [ { :unifex , &quot;~&gt; 1.1&quot; } ] end end","ref":"readme.html#installation","title":"Unifex - Installation","type":"extras"},{"doc":"For detailed usage description see Creating Unifex Natives guide.","ref":"readme.html#usage","title":"Unifex - Usage","type":"extras"},{"doc":"For currently supported types see Supported Types section.","ref":"readme.html#supported-types","title":"Unifex - Supported types","type":"extras"},{"doc":"Unifex depends on the following libraries: Bundlex Shmex","ref":"readme.html#see-also","title":"Unifex - See also","type":"extras"},{"doc":"Copyright 2018, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Unifex - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2018 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"creating_unifex_natives.html","title":"Creating Unifex Natives","type":"extras"},{"doc":"In this tutorial, you will learn how to use Unifex natives to write native code that can be compiled both as NIF and CNode.","ref":"creating_unifex_natives.html#introduction","title":"Creating Unifex Natives - Introduction","type":"extras"},{"doc":"In order to start working, you need to prepare a few things: First, you have to add unifex to your dependencies as well as unifex and bundlex compilers. Please refer to Installation section to see how to do it. After successful installation we should take a look at Bundlex . Unifex uses Bundlex to compile the native code. You can think of Bundlex as a tool that generates build scripts responsible for including proper libs compiling your native code and linking it with mentioned libs. To make it work, create the bundlex.exs file in the project's root directory with the following content: defmodule Example.BundlexProject do use Bundlex.Project def project ( ) do [ natives : natives ( Bundlex . platform ( ) ) ] end def natives ( _platform ) do [ example : [ sources : [ &quot;example.c&quot; ] , interface : [ :nif , :cnode ] , preprocessor : Unifex ] ] end end This defines a native called example , that should be implemented in the example.c file. We'll also need example.spec.exs file, that Unifex needs to generate boilerplate code for compiling the native as NIF and CNode. Both files should be located in the c_src/example folder. Setting Unifex as a preprocessor lets it extend the configuration with the generated code. More details on how to use bundlex can be found in its documentation .","ref":"creating_unifex_natives.html#preparation","title":"Creating Unifex Natives - Preparation","type":"extras"},{"doc":"Let's start by creating a c_src/example directory, and the files that will be needed: mkdir -p c_src/example cd c_src/example touch example.c touch example.h touch example.spec.exs Here are the contents of example.spec.exs : module Example interface [ NIF , CNode ] spec foo ( num :: int ) :: { :ok :: label , answer :: int } Note that here we also specified an interface or even interfaces! It is not necessary because if we didn't do it Unifex would take it from bundlex.exs . However, this is a good practice that makes code clearer and is also a little faster than fetching info from bundlex.exs. Next step is to implement our example.h . Since our example is very simple our example.h will be very simple too: #include &quot;_generated/example.h&quot; It just includes generated header file that contains some function definitions we use in our example.c . The header will be generated by Unifex based on the example.spec.exs file. Now, let's provide required implementation in example.c : #include &quot;example.h&quot; UNIFEX_TERM foo(UnifexEnv* env, int num) { return foo_result_ok(env, num); } The provided foo implementation returns the passed argument, by using foo_result_ok . For every tuple, that might be returned from our Unifex function, there will be generated implementation of result function named [orginal_function_name]_result_[label] , where label is an atom with type label in returned tuple. The type of the first argument of this function will be UnifexEnv* , number and types of the rest of the arguments will depend on the number and types of rest of elements in the returned tuple At this moment the project should successfully compile. Run mix deps.get &amp;&amp; mix compile to make sure everything is fine. In c_src/_generated/ directory there should appear files both for usage as NIF and CNode. Types With Unifex, you can use some of built-in Elixir types (see more in documentation ), as well as your custom types. Currently, we support defining enums and structs. If you want to add structs or enums to the API of your native functions, you have to define them in the *.spec.exs file. There is an example of this: type my_enum :: :option_one | :option_two | :option_three | :option_four | :option_five type my_struct :: % My.Struct { id : int , data : [ int ] , name : string } type nested_struct :: % Nested.Struct { inner_struct : my_struct , id : int } Then, we will generate two versions of native declarations of our custom types, each for C and C++ . An example of version for C is posted below enum MyEnum_t { MY_ENUM_OPTION_ONE, MY_ENUM_OPTION_TWO, MY_ENUM_OPTION_THREE, MY_ENUM_OPTION_FOUR, MY_ENUM_OPTION_FIVE }; typedef enum MyEnum_t MyEnum; struct my_struct_t { int id; int *data; unsigned int data_length; char *name; }; typedef struct my_struct_t my_struct; struct nested_struct_t { my_struct inner_struct; int id; }; typedef struct nested_struct_t nested_struct; The name of enum will be translated to PascalCase, specific options will be prefixed with enum name and translated to MACRO_CASE. Remember, that in C it is forbidden to make a cyclic chain of containment in the way, that it was made above. Now, you can use your custom types, like basic ones, e.g. spec example_function ( in_enum :: my_enum , in_struct :: nested_struct ) :: { :ok :: label , out_struct :: my_struct } | { :error :: label , reason :: atom } UNIFEX_TERM example_function(UnifexEnv *env, MyEnum in_enum, nested_struct in_struct) { if (in_enum == MY_ENUM_OPTION_ONE) { return example_function_result_error(env, &quot;failed&quot;); } return example_function_result_ok(env, in_struct.inner_struct); } If you want to pass enum to Unifex function on Elixir side, you have to use atom (this same, that was used in enum definition in *.spec.exs file). By analogy, the result of Unifex function returning enum will be visible as an atom on the Elixir side. What is important, declaration of a specific struct in *.spec.exs will not automatically make it available in your Elixir code - you are responsible for providing struct module on your own.","ref":"creating_unifex_natives.html#native-code","title":"Creating Unifex Natives - Native code","type":"extras"},{"doc":"NIF All you have to do in order to access natively implemented functions is to create a module with the name as defined in example.spec.exs and to use Unifex.Loader there: defmodule Example do use Unifex.Loader end And that's it! You can now run iex -S mix and check it out yourself: iex(1)&gt; Example . foo ( 10 ) { :ok , 10 } CNode In case of CNodes , module with Unifex.Loader is unnecessary. We would just do: iex(2)&gt; require Unifex.CNode Unifex.CNode iex(3)&gt; { :ok , cnode } = Unifex.CNode . start_link ( :example ) { :ok , % Unifex.CNode { bundlex_cnode : % Bundlex.CNode { node : :&quot;bundlex_cnode_0_4eb957f2-fd47-47c2-b816-6e9c580e658a@michal&quot; , server : # PID &lt; 0 . 259 . 0 &gt; } , node : :&quot;bundlex_cnode_0_4eb957f2-fd47-47c2-b816-6e9c580e658a@michal&quot; , server : # PID &lt; 0 . 259 . 0 &gt; } } iex ( bundlex_app_4eb957f2 - ... ) 4 &gt; Unifex.CNode . call ( cnode , :foo , [ 10 ] ) { :ok , 10 }","ref":"creating_unifex_natives.html#running-code","title":"Creating Unifex Natives - Running code","type":"extras"},{"doc":"You can find more complete projects here . Also check out how we use Unifex in our repositories and please refer to Unifex.Specs.DSL module's documentation to see how to create more advanced *.spec.exs files.","ref":"creating_unifex_natives.html#more-examples","title":"Creating Unifex Natives - More examples","type":"extras"},{"doc":"This page was moved, see Creating Unifex natives","ref":"creating_unifex_nif.html","title":"Creating Unifex NIF","type":"extras"},{"doc":"Unifex supports generating code both for usage with NIF's and CNode's. Nevertheless, some types can be not implemented yet. Below we present which types you can use at this moment. You can also refer to #42 to see state of work on remaining types.","ref":"supported_types.html","title":"Supported types","type":"extras"},{"doc":"type as function parameter as return type atom yes yes bool yes yes unsigned yes yes uint64 yes yes int yes yes int64 yes yes float yes yes list yes yes payload yes yes pid yes yes string yes yes","ref":"supported_types.html#nif","title":"Supported types - NIF","type":"extras"},{"doc":"type as function parameter as return type atom yes yes bool yes yes unsigned yes yes uint64 no no int yes yes int64 no no float yes yes list yes yes payload yes yes pid yes yes string yes yes","ref":"supported_types.html#cnode","title":"Supported types - CNode","type":"extras"},{"doc":"List of examples, how specific type in *.spec.exs will be translated onto native side Elixir type Native type atom char * bool int float double int int int64 int64_t payload UnifexPayload pid UnifexPid state UnifexState * string char * uint64 uint64_t unsigned unsigned int [int] int * , unsigned int","ref":"supported_types.html#types-mapping","title":"Supported types - Types mapping","type":"extras"}]